Subject: 24.3; argument NO-ENABLE of 'load-theme' ignored in new frames

From: JuanLeon Lahoz <[email-masked]>
Date: Wed, 19 Jun 2013 14:49:22 +0200

I think this is a bug but I am enjoying it as a feature.

With emacs -Q, I eval "(load-theme 'dichromacy t t)".  Nothing changes, as
expected since per the doc:

         If optional arg NO-ENABLE is non-nil, load the theme but don't
enable
         it, unless the theme was already enabled.

But if I create a new frame, the frame has the dichromacy theme enabled.

If this is a feature, I think documentation is somewhat misleading.

Also, argument NO-ENABLE is ignored if the theme had been enabled in the
previous session:

emacs -Q and then eval

(load-theme 'dichromacy t)
(load-theme 'tango t)
(load-theme 'dichromacy t t)

dichromacy is enabled

Again, maybe the documentation is not 100% clear and this is not a bug, but
a limitation.

Anyways, I like very much the ability to use different themes in different
frames (load-theme-buffer-local does not apply to minibuffer nor mode-line),
which I partially enjoy with:

(load-theme my-main-theme t)
(load-theme my-theme-for-emacsclient-frames t t)

Thanks
juanleon

In GNU Emacs 24.3.1 (x86_64-unknown-linux-gnu, GTK+ Version 3.4.2)
 of 2013-05-14 on malaz
Windowing system distributor `The X.Org Foundation', version 11.0.11103000
System Description:    Ubuntu 12.04.2 LTS

Configured using:
 `configure '--with-x-toolkit=gtk3''

Important settings:
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix
  default enable-multibyte-characters: t

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent input:
C-y <up> <return> <S-insert> <left> <left> <left> <down>
<C-left> C-SPC <C-right> C-w <up> <C-right> <C-right>
<C-right> <C-left> ' C-y M-d M-d M-d <end> C-x C-e
C-x C-e C-x C-e <down> <up> C-x C-e <down> M-x n e
w <tab> - f r <tab> <return> <switch-frame> <help-echo>
M-x d e l e <tab> f r <tab> <return> M-x <up> <up>
<return> <switch-frame> M-x <up> <up> <return> <left>
C-x C-e <up> <right> C-k M-x s e n <tab> <backspace>
<backspace> <backspace> r e p o <tab> r <tab> <ret
urn>

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.
Mark set [4 times]
t [4 times]
Making completion list...
You can run the command `delete-frame' with C-x 5 0 [2 times]
t
Making completion list...

Load-path shadows:
None found.

Features:
(shadow sort gnus-util mail-extr emacsbug message format-spec rfc822 mml
mml-sec mm-decode mm-bodies mm-encode mail-parse rfc2231 mailabbrev
gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums mm-util
mail-prsvr mail-utils help-mode easymenu dichromacy-theme time-date
tooltip ediff-hook vc-hooks lisp-float-type mwheel x-win x-dnd tool-bar
dnd fontset image regexp-opt fringe tabulated-list newcomment lisp-mode
register page menu-bar rfn-eshadow timer select scroll-bar mouse
jit-lock font-lock syntax facemenu font-core frame cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese hebrew greek romanian slovak czech european ethiopic indian
cyrillic chinese case-table epa-hook jka-cmpr-hook help simple abbrev
minibuffer loaddefs button faces cus-face macroexp files text-properties
overlay sha1 md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote make-network-process dynamic-setting
system-font-setting font-render-setting move-toolbar gtk x-toolkit x
multi-tty emacs)